function [nbcvect, out] = focspooling_fake2(in, k, alpha_vect, sigma, r, l, chat, ~, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh, ...
        as, cmin, cmin2, lambda, ls, nk, kappavect, distkappa, ~, ~)

cl_vect = zeros(1,nk);
c_vect = zeros(1,nk);

if (cmin <= chat && cmin2 ==0) %solve for consumption when kappa shock is largest
    cl_vect(nk) = exp(in(1)) + chat;
    c_vect(nk)  = exp(in(2));
    cl_vect(1:nk-1) = cl_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    c_vect(1:nk-1) = c_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;  
elseif (cmin > chat && cmin2 == 0) %solve for consumption when kappa shock is largest
    %cl_vect(1) = exp(in(1)) + chat;
    cl_vect(k) = exp(in(1)) + chat;
    c_vect(nk)  = exp(in(2));
    %cl_vect(2:nk) = max(cmin,cl_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    cl_vect(1:k-1) = cl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    cl_vect(k+1:nk) = cmin;
    %display(cl_vect);
    c_vect(1:nk-1) = c_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;  
elseif (cmin <= chat && cmin2 > 0) %solve for consumption when kappa shock is largest when not in NH and smallest when in NH
    cl_vect(nk) = exp(in(1)) + chat;
    c_vect(1)  = exp(in(2));
    t = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - c_vect(1);     
    cl_vect(1:nk-1) = cl_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    %c_vect(2:nk) = max(cmin2-t,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy); 
    c_vect(2:nk) = max(cmin2,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy); 
else %(cmin > chat && cmin2 > 0) %solve for consumption when kappa shock is largest when not in NH and smallest when in NH
    cl_vect(k) = exp(in(1)) + chat;
    c_vect(1)  = exp(in(2));
    %t = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - c_vect(1);   
    cl_vect(1:k-1) = cl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    cl_vect(k+1:nk) = cmin;
    %c_vect(2:nk) = max(cmin2-t,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    c_vect(2:nk) = max(cmin2,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
end  

cl0_vect = max((1+r)*as - l+(1-tau)*wo+ls-r*as*tau- kappavect.*wy,cmin);
c0_vect = max(cmin2,(1+r)*as+(1-tau)*wo+ls-r*as*tau- kappavect.*wy);

U2l = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* c_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*c_vect.^(1-sigma)./(1-sigma)).*distkappa );  
U2l0 = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*c0_vect.^(1-sigma)./(1-sigma)).*distkappa );  
U2h = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* c_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*c_vect.^(1-sigma)./(1-sigma)).*distkappa ); 
U2h0 = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*c0_vect.^(1-sigma)./(1-sigma)).*distkappa ); 

dUtemp = alpha_vect.* survprobl.*thetal_vect .* (cl_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
%dU2ldx = dUtemp(1) +  sum(dUtemp2(cl_vect(2:nk)>cmin)); 
dU2ldx = dUtemp(1) +  sum(dUtemp2(1:k-1)); 
%dU2l0dx = 0;
%dUtemp3 = alpha_vect.* survprobl.*(1-thetal_vect) .* c_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobl).*udeathprime(c_vect) .*distkappa;
dUtemp3 = alpha_vect.* survprobl.*(1-thetal_vect) .* c_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobl).*c_vect.^(-sigma) .*distkappa;

dUtemp4 = dUtemp3(2:nk);
dU2ldt =-dUtemp(1) - sum(dUtemp2(1:k-1)) - dUtemp3(1)-sum(dUtemp4(c_vect(2:nk)>cmin2));

%nbcvect = zeros(1,1);
nbcvect(1) = U2h - U2h0; %PC2h (2)


out(1) = (phi.*survprobl.*sum(thetal_vect.*distkappa) + (1-phi).*survprobh.*sum(thetah_vect.*distkappa)).*lambda + dU2ldx./dU2ldt;
out(2) =  U2l - U2l0; %PC2l (1)
%out(3) = lambda1;
%out(4) = lambda2;
        
%keyboard