function dist = get_discrete_logn(grid, mean, stdev)
        
        n = length(grid);
        
        dist = zeros(1,n);
               
        wvect = (grid(2:n) - grid(1:n-1))/2;
        
        
        lhpts = zeros(1,n);
        rhpts = zeros(1,n);

        lhpts(2:n) = grid(2:n) - wvect;
        rhpts(1:n-1) = grid(1:n-1) + wvect;
        
        cdf_l = cdf('norm', lhpts,mean,stdev);
        cdf_r = cdf('norm', rhpts,mean,stdev);
       
        
        dist = cdf_r - cdf_l; %area 1
        dist(1) = cdf_r(1);
        dist(n) = 1-sum(dist(1:n-1));
        
        
    end 