    
function as_gini = get_gini(distyhvect, asvect)

    cumdist = cumsum(distyhvect);
    cumdist_as = cumsum(asvect.*distyhvect)/sum(asvect.*distyhvect);
    as_gini = 1-sum( (cumdist(2:end) - cumdist(1:end-1)).*(cumdist_as(2:end) + cumdist_as(1:end-1)) );
    
end