%Flags
calibrate_exante = 0; %Set to 1 to output ex-ante stats and pause 

Ns = 1; %number of solution types (1 solves only monopolist with private info., 2 solves that plus monopolist without private info.)
Np = 1; %2; %number of loops over profits and tax rate

%guess on tax rate
taug1 = 0; 
taug2 = 0; 
taug3 = 0; 
profitsg =  0; 

if UseDoRuns == 1
    betaannual = betaDoRuns;
    alpha_vect = alphaDoRuns*ones(1,nk);
else
    betaannual = 0.963; 
    alpha_vect = 0.21*ones(1,nk); %weight on consumption during NH period %set to 1 to shutdown kappa shock and set kappavect to 0
end

sigma = 2; %preference parameter
r = 0; 
l = 0.0931;  %0.0931;  %loss

survtemps=linspace(0.9685620612, 0.360192059,nk);

beta = betaannual^40;  %discount factor

chat = 0.0;  %consumption cost of NH
chat2 = 0;


if UseDoRuns == 1
    cminvect = [cminDoRuns 0.02 0.001 0.152 0.15 0.15 0.2 0.3]; %use 0.11 to get both
else
    cminvect = [0.027 0.02 0.001 0.152 0.15 0.15 0.2 0.3]; %use 0.11 to get both
end

cmin2 = 0.0; 
cmin3 = 0.01855;

Nc = 1; %look over values of cmin

lambda =  1.195;    %load 1 means no load, NoAdminCosts: 1 
k = 0.0190; %fixed claim processing cost, NoAdminCosts: 0

%utilty at death as function of c0
udeath = @(x) x.^(1-sigma)/(1-sigma);
udeathprime = @(x) x.^(-sigma);

%udeath = @(x) 0;
%udeathprime =@(x) 0;

%income is log normal
%mean_logy = 0;
stdev_logy = 0.8; %1.0; %0.78 %0.7; %1;
%mean_y = exp(mean_logy+stdev_logy^2/2);
mean_y = 1; %1.277621313204887; %1*2;
mean_logy = log(mean_y)-stdev_logy^2/2;
stdev_y = sqrt(exp(2*(mean_logy+stdev_logy^2)) - exp(2*mean_logy+stdev_logy^2));
%stdev_y/mean_y

%health is beta distribution
b_h = 6.3; %6.7;  %6.3;
%a_h = 1.53096
a_h = 0.196*b_h/(1.0-0.196); 
cov_yh = -0.29; %-0.4; %-0.29;  %correlation between frailty and income so if positive means higher income are more frail
              %if negative means higher income are less frail

%ygrid = linspace(0.05*mean_y,3*mean_y,ny); %X

%to go back to previous baseline yptemp = 83 and switch lines 94 and 95
yptemp = 83; %82; %79; %58; %80;
ygrid = exp(linspace(mean_logy-3*stdev_logy,mean_logy+3*stdev_logy,yptemp)); %X
%np = 15;
np=30;
%np = 9;
ygrid1 = linspace(ygrid(t1+1), ygrid(t1+8), np);
ygrid2 = linspace(ygrid(t1+9), ygrid(t1+2*8-1), np);
ygrid3 = linspace(ygrid(t1+2*8), ygrid(t1+3*8-2), t2);
%ygrid = [ygrid(1:t1) ygrid1 ygrid2 ygrid3 ygrid(t1+3*8-1:yptemp)];
ygrid = [ygrid(1:t1) ygrid1 ygrid2 ygrid3 ygrid(t1+3*8:yptemp)];

%hgrid = linspace(0.06,0.6,nh);  %fraility (less to more)
hgrid = [0.05 0.112 0.156 0.24 0.37];  %fraility (less to more)


distyh = get_discrete_dist(ygrid, hgrid, mean_logy, stdev_logy,a_h,b_h,cov_yh);

%baseline
 distyh(121,5) = distyh(121,5) - 0.0017;
 distyh(122,5) = distyh(122,5) + 0.0017;
 distyh(121,1) = distyh(121,1) - 0.003;
 distyh(122,1) = distyh(122,1) + 0.003;
 distyh(122,2) = distyh(122,2) - 0.0022;
 distyh(123,2) = distyh(123,2) + 0.0022; 
 distyh(131,3) = distyh(131,3) - 0.0012;
 distyh(130,3) = distyh(130,3) + 0.0012;  
 distyh(135,3) = distyh(135,3) - 0.0007;
 distyh(136,3) = distyh(136,3) + 0.0007;   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
disty = sum(distyh,2)';
disth = sum(distyh,1);
ygrid = ygrid/sum(ygrid.*disty)*mean_y;
%keyboard
ymat = repmat(ygrid',1,nh); %income
yomat = repmat(ygrid'.*exp(linspace(log(0.686),log(0.4725),ny))',1,nh); %ymat*0.7; %*0.45;

survprobshmat = [0.79845665*ones(1,t1)	0.8428102098*ones(1,t3)	0.8717391304*ones(1,t3)	0.8959064327*ones(1,t2)	0.9122089364*ones(1,t1);
0.7426725133*ones(1,t1)	0.7917669716*ones(1,t3)	0.8241101585*ones(1,t3)	0.8526810392*ones(1,t2)	0.8652503794*ones(1,t1);
0.7019822283*ones(1,t1)	0.7297169811*ones(1,t3)	0.7647208769*ones(1,t3)	0.7999462221*ones(1,t2)	0.8126404494*ones(1,t1);
0.6340341656*ones(1,t1)	0.658706916*ones(1,t3)	0.6950873878*ones(1,t3)	0.7147001934*ones(1,t2)	0.7327258922*ones(1,t1);
0.5607866508*ones(1,t1)	0.568358209*ones(1,t3)	0.6008298755*ones(1,t3)	0.6121941103*ones(1,t2)	0.6371317158*ones(1,t1)];
survprobshmat = survprobshmat';
survprobslmat = survprobshmat;

%  survprobshmat = repmat([1	1	1	1	1],[ny 1]);
%  survprobslmat = repmat([1	1	1	1	1],[ny 1]);

% survprobshmat = repmat([0.99	0.99	0.99	0.99	0.99],[ny 1]);
% survprobslmat = repmat([0.99	0.99	0.99	0.99	0.99],[ny 1]);


etadatavect = [0.3518*ones(1,t1)	0.3335*ones(1,t3)	0.3208*ones(1,t3)	0.3064*ones(1,t2)	0.2899*ones(1,t1);
0.3218*ones(1,t1)	0.3289*ones(1,t3)	0.3172*ones(1,t3)	0.3085*ones(1,t2)	0.2851*ones(1,t1);
0.3081*ones(1,t1)	0.3094*ones(1,t3)	0.3*ones(1,t3)	0.2975*ones(1,t2)	0.2893*ones(1,t1);
0.2895*ones(1,t1)	0.2924*ones(1,t3)	0.2943*ones(1,t3)	0.2956*ones(1,t2)	0.2895*ones(1,t1);
0.2823*ones(1,t1)	0.2856*ones(1,t3)	0.2896*ones(1,t3)	0.2952*ones(1,t2)	0.2941*ones(1,t1)];

etadatavect = etadatavect';

if UseDoRuns == 1
    kappamax = kappamaxDoRuns; %0.9
    kappamin = kappaminDoRuns; %0.4     
    meankappa = meankappaDoRuns; %0.55; %0.55
    stdlnkappa = stdlnkappaDoRuns; %0.245; %0.245
else
    kappamax = 0.99; %0.9
    kappamin = 0.2; %0.4    
    meankappa = 0.65; %0.55; %0.55
    stdlnkappa = 0.5; %0.5; %0.26; %0.245
end
lnkappavect = linspace(log(kappamin),log(kappamax),nk);
invmeankappa = kappamax+kappamin-meankappa;
meanlnkappa = log(invmeankappa)-stdlnkappa^2/2;
%lnkappavect = linspace(meanlnkappa-2*stdlnkappa,meanlnkappa+2*stdlnkappa,nk);
kappavect = exp(lnkappavect);
distkappa = get_discrete_logn(lnkappavect, log(invmeankappa)-stdlnkappa^2/2, stdlnkappa);
%distkappa(nk) = 0;
%distkappa(1) = 1-sum(distkappa(2:nk));
alphayh = ones(ny,nh)/ny/nh; %distribution of shares in insurer across y and h
%to shut down 
%alphayh = zeros(ny,nh)/ny/nh; %distribution of shares in insurer across y and h
kappavectt = kappamin+kappamax-kappavect;
kappavectt = fliplr(kappavectt);
distkappat = fliplr(distkappa);
%keyboard

%figure(111); plot(log(kappavectt),distkappat)
kappavect=kappavectt;
distkappa = distkappat;
%keyboard
%kappavect = linspace(0.1,0.5,nk);

%% Compute ex-ante statistics 
%Survival probabilities
FracSurvbyyh = survprobslmat.*phimat + survprobshmat.*(1-phimat);
FracSurvbyy = sum(FracSurvbyyh.*distyh ,2)'./disty;
FracSurvbyh = sum( FracSurvbyyh.*distyh ,1)./disth;
FracSurv = sum(sum( FracSurvbyyh.*distyh ));

%NH probabilities
distkappamat = repmat(shiftdim(distkappa,-1),[ny,nh,1]);
FracEnterNHbyyh = survprobslmat.*sum(thetalmat.*distkappamat,3).*phimat + survprobshmat.*sum(thetahmat.*distkappamat,3).*(1-phimat);
FracEnterNHbyh = sum( FracEnterNHbyyh.*distyh ,1)./disth;
FracEnterNHbyy = sum( FracEnterNHbyyh.*distyh ,2)'./disty;
FracEnterNH = sum(sum( FracEnterNHbyyh.*distyh ));

FracSurvsEnterNHbyyh = FracEnterNHbyyh./(survprobslmat.*phimat + survprobshmat.*(1-phimat));
FracSurvsEnterNHbyh = sum( FracSurvsEnterNHbyyh.*distyh ,1)./disth;
FracSurvsEnterNHbyy = sum( FracSurvsEnterNHbyyh.*distyh ,2)'./disty;
FracSurvsEnterNH = sum(sum( FracSurvsEnterNHbyyh.*distyh ));

%for the unconditional variance of NH entry
FracEnterNH2byyh = survprobslmat.*sum((thetalmat).^2.*distkappamat,3).*phimat + survprobshmat.*sum((thetahmat).^2.*distkappamat,3).*(1-phimat);
FracEnterNH2byh = sum( FracEnterNH2byyh.*distyh ,1)./disth;
FracEnterNH2byy = sum( FracEnterNH2byyh.*distyh ,2)'./disty;
FracEnterNH2 = sum(sum( FracEnterNH2byyh.*distyh ));

%for the variance of NH entry conditional on survival
FracSurvsEnterNH2byyh = FracEnterNH2byyh./(survprobslmat.*phimat + survprobshmat.*(1-phimat));
FracSurvsEnterNH2byh = sum( FracSurvsEnterNH2byyh.*distyh ,1)./disth;
FracSurvsEnterNH2byy = sum( FracSurvsEnterNH2byyh.*distyh ,2)'./disty;
FracSurvsEnterNH2 = sum(sum( FracSurvsEnterNH2byyh.*distyh ));

%by high and low types
FracEnterNHbyyh_l = survprobslmat.*sum(thetalmat.*distkappamat,3);
FracEnterNHbyyh_h = survprobshmat.*sum(thetahmat.*distkappamat,3);
FracEnterNH2byyh_l = survprobslmat.*sum((thetalmat).^2.*distkappamat,3);
FracEnterNH2byyh_h = survprobshmat.*sum((thetahmat).^2.*distkappamat,3);
FracSurvsEnterNHbyyh_l = FracEnterNHbyyh_l./(survprobslmat);
FracSurvsEnterNHbyyh_h = FracEnterNHbyyh_h./(survprobshmat);
FracSurvsEnterNH2byyh_l = FracEnterNH2byyh_l./(survprobslmat);
FracSurvsEnterNH2byyh_h = FracEnterNH2byyh_h./(survprobshmat);


%health distribution moments
ng = 5;    
phi_mean = sum(hgrid.*disth);
[phi_qmeans,  phi_shares, phi_qvalues, phi_cutoffs] = get_dist_stats(hgrid, disth, linspace(1/ng,1,ng));
[phi_pmeansBAD,  phi_psharesBAD, phi_pvalues, phi_pcutoffs] = get_dist_stats(hgrid, disth, [0.5 0.9 0.95 0.99]); 
[NHentry_byhq_means,  NHentry_byhq_shares] = get_dist_stats_x(FracEnterNHbyh, disth, phi_cutoffs, ng);
[NHentrysurvs_byhq_means,  NHentrysurvs_byhq_shares] = get_dist_stats_x(FracSurvsEnterNHbyh, disth, phi_cutoffs, ng);
[NHentry2_byhq_means,  NHentry2_byhq_shares] = get_dist_stats_x(FracEnterNH2byh, disth, phi_cutoffs, ng);
[NHentry2survs_byhq_means,  NHentry2survs_byhq_shares] = get_dist_stats_x(FracSurvsEnterNH2byh, disth, phi_cutoffs, ng);
[survs_byhq_means,  survs_byhq_shares] = get_dist_stats_x(FracSurvbyh, disth, phi_cutoffs, ng);
phi_gini=get_gini(disth,hgrid); 

VarNHentry_byhq = NHentry2_byhq_means-(NHentry_byhq_means).^2;
VarNHentrysurvs_byhq = NHentry2survs_byhq_means-(NHentrysurvs_byhq_means).^2;
CofVArNHentry_byhq = sqrt(VarNHentry_byhq)./NHentry_byhq_means;
CofVArNHentrysurvs_byhq = sqrt(VarNHentrysurvs_byhq)./NHentrysurvs_byhq_means;

stdevNHentry = sqrt(FracEnterNH2-FracEnterNH.^2);
CofVarNHentry = stdevNHentry./FracEnterNH;
stdevNHentry_survs = sqrt(FracSurvsEnterNH2-FracSurvsEnterNH.^2);
CofVarNHentry_survs = stdevNHentry./FracSurvsEnterNH;

FracEnterNH2byyh_test = sum((repmat(survprobslmat,[1 1 50]).*thetalmat).^2.*distkappamat,3).*phimat + sum((repmat(survprobshmat,[1 1 50]).*thetahmat).^2.*distkappamat,3).*(1-phimat);
FracEnterNH2byh_test = sum( FracEnterNH2byyh_test.*distyh ,1)./disth;
FracEnterNH2byy_test = sum( FracEnterNH2byyh_test.*distyh ,2)'./disty;
FracEnterNH2_test = sum(sum( FracEnterNH2byyh_test.*distyh ));
[NHentry2_byhq_means_t,  NHentry2_byhq_shares_t] = get_dist_stats_x(FracEnterNH2byh_test, disth, phi_cutoffs, ng);
VarNHentry_byhq_t = NHentry2_byhq_means_t-(NHentry_byhq_means).^2;
stdevNHentry_t = sqrt(FracEnterNH2_test-FracEnterNH.^2);
CofVarNHentry_t = stdevNHentry./FracEnterNH;

%income distribution moments
ng = 5;    
y_mean = sum(ygrid.*disty);
[y_qmeans,  y_shares, y_qvalues, y_cutoffs] = get_dist_stats(ygrid, disty, linspace(1/ng,1,ng));
[y_pmeansBAD,  y_psharesBAD, y_pvalues, y_pcutoffs] = get_dist_stats(ygrid, disty, [0.5 0.9 0.95 0.99]); %want the y_pvalues here
[NHentry_byyq_means,  NHentry_byyq_shares] = get_dist_stats_x(FracEnterNHbyy, disty, y_cutoffs, ng);
[NHentrysurvs_byyq_means,  NHentrysurvs_byyq_shares] = get_dist_stats_x(FracSurvsEnterNHbyy, disty, y_cutoffs, ng);
[NHentry2_byyq_means,  NHentry2_byyq_shares] = get_dist_stats_x(FracEnterNH2byy, disty, y_cutoffs, ng);
[NHentry2survs_byyq_means,  NHentry2survs_byyq_shares] = get_dist_stats_x(FracSurvsEnterNH2byy, disty, y_cutoffs, ng);
[survs_byyq_means,  survs_byyq_shares] = get_dist_stats_x(FracSurvbyy, disty, y_cutoffs, ng);
[phi_byyq_means,  phi_byyq_shares] = get_dist_stats_x(sum(repmat(hgrid,ny,1).*distyh,2)'./disty, disty, y_cutoffs, ng);
y_gini=get_gini(disty,ygrid);    

VarNHentry_byyq = NHentry2_byyq_means-(NHentry_byyq_means).^2;
VarNHentrysurvs_byyq = NHentry2survs_byyq_means-(NHentrysurvs_byyq_means).^2;
CofVArNHentry_byyq = sqrt(VarNHentry_byyq)./NHentry_byyq_means;
CofVArNHentrysurvs_byyq = sqrt(VarNHentrysurvs_byyq)./NHentrysurvs_byyq_means;


yupper = 0.875;
ylower = 0.125; 
cdisty = cumsum(disty);
yup1 = find(cdisty<yupper,1,'last');
ylp1 = find(cdisty<ylower,1,'last');
yuppermom = ((cdisty(yup1+1)-yupper)*yomat(yup1,1)/ygrid(yup1) + (yupper-cdisty(yup1))*yomat(yup1+1,1)/ygrid(yup1+1))/(cdisty(yup1+1)-cdisty(yup1));
ylowermom = ((cdisty(ylp1+1)-ylower)*yomat(ylp1,1)/ygrid(ylp1) + (ylower-cdisty(ylp1))*yomat(ylp1+1,1)/ygrid(ylp1+1))/(cdisty(ylp1+1)-cdisty(ylp1));



%joint distribution of income and fraility moments
%income moments for each frailty quintile 
[y_qmeans_byhq,  y_shares_byhq, y_qvalues_byhq,  y_cutoffs_byhq] = get_dist_stats_jointx(ymat, distyh, ...
    phi_cutoffs, disth, ng);
%frailty moments for each income quintile
[phi_qmeans_byyq,  phi_shares_byyq, phi_qvalues_byyq,  phi_cutoffs_byyq] = get_dist_stats_jointx(repmat(hgrid,ny,1)', distyh', ...
    y_cutoffs, disty, ng);

%income moments for each frailty quartile 
[phi_qmeans2,  phi_shares2, phi_qvalues2, phi_cutoffs2] = get_dist_stats(hgrid, disth, linspace(1/4,1,4));
[y_qmeans_byhqr, y_shares_byhqr, y_qvalues_byhqr, y_cutoffs_byhqr] = get_dist_stats_jointx(ymat, distyh, ...
    phi_cutoffs2, disth, 4); 




    
if calibrate_exante == 1    
    keyboard    
end

%% Solve for ex-ante and ex-post PO allocations and utility
%spp


%% Solve the Monopolist's problem with and without PI and various values of
%%cmin

UPIvect = zeros(1,Nc);
UnPIvect = zeros(1,Nc);
ProfitsPIvect = zeros(1,Nc);
ProfitsnPIvect = zeros(1,Nc);
FracMTSIPIvect = zeros(1,Nc);
FracMTSInPIvect = zeros(1,Nc);
FracLTCIPIvect= zeros(1,Nc);
FracLTCInPIvect = zeros(1,Nc);
	

for jj=1:Nc
    cmin = cminvect(jj);
    economy

    UPIvect(jj) = Utilityvect(1);
    UnPIvect(jj) = Utilityvect(2);
    ProfitsPIvect(jj) = Profitsvect(1);
    ProfitsnPIvect(jj) = Profitsvect(2);    
    
    FracMTSIPIvect(jj) = NumMTSIvect(1);
    FracMTSInPIvect(jj) =NumMTSIvect(2);
    FracLTCIPIvect(jj) =FracLTCIvect(1);
    FracLTCInPIvect(jj) =FracLTCIvect(2);
    
end

