function out = FOCp(in, lncl, k, alpha_vect, sigma, r, chat, ~, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh, ...
        ~, cmin, cmin2, lambda, ls, nk, kappavect, distkappa, ~, ~)

cl_vect = zeros(1,nk);
c_vect = zeros(1,nk);

if (cmin > chat && cmin2 == 0) %solve for consumption when kappa shock is largest
    %cl_vect(1) = exp(lncl) + chat;
    cl_vect(k) = exp(lncl) + chat;
    c_vect(nk)  = exp(in);
    %cl_vect(2:nk) = max(cmin,cl_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    cl_vect(1:k-1) = cl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    cl_vect(k+1:nk) = cmin;
    %display(cl_vect);
    c_vect(1:nk-1) = c_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;  
else %(cmin > chat && cmin2 > 0) %solve for consumption when kappa shock is largest when not in NH and smallest when in NH
    cl_vect(k) = exp(lncl) + chat;
    c_vect(1)  = exp(in);
    %t = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - c_vect(1);   
    cl_vect(1:k-1) = cl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    cl_vect(k+1:nk) = cmin;
    %c_vect(2:nk) = max(cmin2-t,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy); 
    c_vect(2:nk) = max(cmin2,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy); 
end  

dUtemp = alpha_vect.* survprobl.*thetal_vect .* (cl_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
dU2ldx = dUtemp(1) +  sum(dUtemp2(cl_vect(2:nk)>cmin));  

%dUtemp3 = alpha_vect.* survprobl.*(1-thetal_vect) .* c_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobl).*udeathprime(c_vect) .*distkappa;
dUtemp3 = alpha_vect.* survprobl.*(1-thetal_vect) .* c_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobl).*c_vect.^(-sigma) .*distkappa;
%dU2ldt = -dUtemp(1) - sum(dUtemp2(cl_vect(2:nk)>cmin)) -sum(dUtemp3);
dUtemp4 = dUtemp3(2:nk);
dU2ldt =-dUtemp(1) - sum(dUtemp2(1:k-1)) - dUtemp3(1)-sum(dUtemp4(c_vect(2:nk)>cmin2));

out = (phi.*survprobl.*sum(thetal_vect.*distkappa) + (1-phi).*survprobh.*sum(thetah_vect.*distkappa)).*lambda + dU2ldx./dU2ldt;

        
%keyboard