function out = PC2l(in, lncl, k, alpha_vect, sigma, r, l, chat, chat2, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh, ...
        as, cmin, cmin2, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime)

cl_vect = zeros(1,nk);
c_vect = zeros(1,nk);

if (cmin > chat && cmin2 == 0) %solve for consumption when kappa shock is largest
    
    cl_vect(k) = exp(lncl) + chat;
    c_vect(nk)  = exp(in);
    
    cl_vect(1:k-1) = cl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    cl_vect(k+1:nk) = cmin;
    
    c_vect(1:nk-1) = c_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;  

else %(cmin > chat && cmin2 > 0) %solve for consumption when kappa shock is largest when not in NH and smallest when in NH
    cl_vect(k) = exp(lncl) + chat;
    c_vect(1)  = exp(in);
    %t = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - c_vect(1);   
    cl_vect(1:k-1) = cl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    cl_vect(k+1:nk) = cmin;
    %c_vect(2:nk) = max(cmin2-t,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy); 
    c_vect(2:nk) = max(cmin2,c_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy); 
end  

cl0_vect = max((1+r)*as - l+(1-tau)*wo+ls-r*as*tau- kappavect.*wy,cmin);
c0_vect = max(cmin2,(1+r)*as+(1-tau)*wo+ls-r*as*tau- kappavect.*wy);

U2l = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* c_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*udeath(c_vect)).*distkappa );  
U2l0 = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*udeath(c0_vect)).*distkappa );  

out =  U2l - U2l0; %PC2l (1)

