 function [out, maxprofitsvect, maxtlvect, maxxlvect, maxthvect, maxxhvect,...
     optcase, poolsolvect, maxcy, maxcll, maxchl, maxcl, maxch, maxU1] =...
     U0_2(in, phi, wy, wo, ls, nk, soltype, sigma, r, l, chat, chat2, tau, thetal_vect,...
     thetah_vect, survprobl, survprobh, beta, alpha_vect, cmin, cmin2, lambda, k, distkappa, kappavect, udeath, udeathprime,cnkspvect,chkspvect2)
%takes in assets and passes back newborn utility

poolsolvect = zeros(1,4);
maxprofitsvect = zeros(1,4);

as = in;

cNH0 = (1+r)*as - l + wo*(1-tau) + ls -r*as*tau -kappavect(nk)*wy; % consumption in NH when contracts are 0 and kappa is kappavect(nk)
if max(cNH0, cmin) <= chat 
    out = 10000;
    maxcy = 10000;
    maxchl = 10000;
    maxcll = 10000;
    maxch = 10000;
    maxcl = 10000; 
    maxprofitsvect = 10000;
    maxtlvect = 10000;
    maxxlvect = 10000;
    maxthvect = 10000;
    maxxhvect = 10000;
    optcase = 10000;
    poolsolvect = 10000;
    maxU1 = 10000;     
      
    return
end

if max(cNH0+l,cmin2) <= 0
    out = 10000;
    maxcy = 10000;
    maxchl = 10000;
    maxcll = 10000;
    maxch = 10000;
    maxcl = 10000; 
    maxprofitsvect = 10000;
    maxtlvect = 10000;
    maxxlvect = 10000;
    maxthvect = 10000;
    maxxhvect = 10000;
    optcase = 10000;
    poolsolvect = 10000;
    maxU1 = 10000;     
       
    return
end

maxcy = wy*(1-tau) - as;

UseNoTradeCondition =0;

if (UseNoTradeCondition==1)
    ucl0mat = max(cmin,repmat((1+r)*as - l +(1-tau)*wo+ls-r*as*tau,[1 nk]) - kappavect.*wy); 

   

    ucl0mat = (ucl0mat-chat).^(-sigma);


    uc0mat = max(cmin2,repmat((1+r)*as +(1-tau)*wo+ls-r*as*tau,[1 nk]) - kappavect.*wy); 
    uc0mat(uc0mat>cmin2) = (uc0mat(uc0mat>cmin2)).^(-sigma);
    uc0mat(uc0mat==cmin2) = 0;
    udeath0mat = uc0mat;
  
    MRSl0 = sum( survprobl.*alpha_vect.*(thetal_vect .* ucl0mat ).*distkappa )./...
            sum(alpha_vect.*(survprobl.*(thetal_vect .* ucl0mat + (1-thetal_vect) .*uc0mat) + (1-survprobl).*udeath0mat).*distkappa ); 
    if isnan(MRSl0) && sum( survprobl.*alpha_vect.*(thetal_vect .* ucl0mat ).*distkappa ) == 0
        MRSl0 = 0;
    end
    rhsp = lambda*(phi.*survprobl.*sum(thetal_vect.*distkappa)+(1-phi).*survprobh.*sum(thetah_vect.*distkappa));
    %contracts should be zero if this is positive
    rhsplessMRSl0 = rhsp-MRSl0;
    MRSh0 = sum( survprobh.*alpha_vect.*(thetah_vect .* ucl0mat ).*distkappa )./...
            sum(alpha_vect.*(survprobh.*(thetah_vect .* ucl0mat + (1-thetah_vect) .*uc0mat)+(1-survprobh).*udeath0mat).*distkappa ); 
    if isnan(MRSh0) && sum( survprobh.*alpha_vect.*(thetah_vect .* ucl0mat ).*distkappa ) == 0
        MRSh0 = 0;
    end
    rhsph = lambda*survprobh*sum(thetah_vect.*distkappa);
    rhsphlessMRSh0 = rhsph-MRSh0;  

    if rhsplessMRSl0 > 0 && rhsphlessMRSh0>0

        cll_vect = max((1+r)*as - l +(1-tau)*wo +ls -r*as*tau -kappavect.*wy, cmin);
        chl_vect = cll_vect;

        cl_vect = max((1+r)*as +(1-tau)*wo +ls -r*as*tau - kappavect.*wy, cmin2);
        ch_vect = cl_vect;

        U2h = sum( alpha_vect.*( survprobh.*(thetah_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* ch_vect.^(1-sigma)./(1-sigma)) ...
             +(1-survprobh).*udeath(ch_vect)  ).*distkappa ); 
        U2l = sum( alpha_vect.*( survprobl.*(thetal_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* cl_vect.^(1-sigma)./(1-sigma)) ...
             +(1-survprobl).*udeath(cl_vect)  ).*distkappa ); 
        maxU1 = beta* (phi*U2l + (1-phi)*U2h);
        out = (maxcy).^(1-sigma)./(1-sigma) + maxU1 + beta.*sum((1- 0).*kappavect.^(1-sigma).*distkappa).*wy.^(1-sigma)./(1-sigma);
        out = -out;
        maxcll = cll_vect(1);
        maxcl = cl_vect(1);
        maxchl = chl_vect(1);
        maxch = ch_vect(1);

        maxprofitsvect = 0;
        maxtlvect = 0;
        maxxlvect = 0;
        maxthvect = 0;
        maxxhvect = 0;
        optcase = 1;
        poolsolvect = 1; 
        %fprintf(1,'Reject pool\n')

        return

    end    
end


%% Case 1: Neither on MTSI

%Compute optimal contracts and profits under assumption neither type on
%MTSI when get smallest kappa shock kappavect(1)
%All cases from all on MTSI except smallest kappa shock types to no one on
%MTSI



  if (cNH0+kappavect(nk)*wy-kappavect(1)*wy < chat)
    maxprofitsvect(1) = -inf;
  else
     if wy < 0.56 %0.86 %0.6 %-100 %500 %0.560
         maxprofitsvect(1) = -inf;
     else
         NoMTSI;
         maxprofitsvect(1) = profitsmax;
         %maxprofitsvect(1) = NoMTSI(as);
         maxtlvect(1) = tlmax;
         maxxlvect(1) = xlmax;
         maxthvect(1) = thmax;
         maxxhvect(1) = xhmax;
         if pnind ==1 
             poolsolvect(1) = 1;
         end          
     end
  
 end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%this should be uncommented for real runs.
 if wy <  0.56 %0.86 %0.6 %-100 %500 %0.56
    maxprofitsvect(1) = -inf;
    maxprofitsvect(2) = -inf;
    maxtlvect(2) = -inf;
    maxxlvect(2) = -inf;
    maxthvect(2) = -inf;
    maxxhvect(2) = -inf;
 else
    OnlylMTSI;
    maxprofitsvect(2) = profitsmax;
    maxtlvect(2) = tlmax;
    maxxlvect(2) = xlmax;
    maxthvect(2) = thmax;
    maxxhvect(2) = xhmax;
    if pnind ==1 
        poolsolvect(2) = 1;
    end
 end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Case 3: All h types on MTSI but not all l types
if soltype == 1
    %Seems this case is impossible so don't waste time here
    maxprofitsvect(3) = -inf;
    maxtlvect(3) = -inf;
    maxxlvect(3) = -inf;
    maxthvect(3) = -inf;
    maxxhvect(3) = -inf;
else    
    OnlyhMTSI;
    maxprofitsvect(3) = profitsmax;
    maxtlvect(3) = tlmax;
    maxxlvect(3) = xlmax;
    maxthvect(3) = thmax;
    maxxhvect(3) = xhmax;
    %keyboard
end

%% Case 4: all of both types on MTSI
maxprofitsvect(4) = 0;
maxtlvect(4) = 0;
maxxlvect(4) = 0;
maxthvect(4) = 0;
maxxhvect(4) = 0;
poolsolvect(4) = 1;

%Which case maximizes profits
[profitsmax, optcase] = max(maxprofitsvect);
    
cll_vect = max((1+r)*as - maxtlvect(optcase) - l + maxxlvect(optcase)+(1-tau)*wo +ls -r*as*tau -kappavect.*wy, cmin);
chl_vect = max((1+r)*as - maxthvect(optcase) - l + maxxhvect(optcase)+(1-tau)*wo +ls -r*as*tau - kappavect.*wy, cmin);

cl_vect = max(cmin2,(1+r)*as - maxtlvect(optcase)+(1-tau)*wo +ls -r*as*tau - kappavect.*wy);
ch_vect = max(cmin2,(1+r)*as - maxthvect(optcase)+(1-tau)*wo +ls -r*as*tau - kappavect.*wy);

U2h = sum( alpha_vect.*( survprobh.*(thetah_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* ch_vect.^(1-sigma)./(1-sigma)) ...
     +(1-survprobh).*udeath(ch_vect)  ).*distkappa ); 
U2l = sum( alpha_vect.*( survprobl.*(thetal_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* cl_vect.^(1-sigma)./(1-sigma)) ...
     +(1-survprobl).*udeath(cl_vect)  ).*distkappa ); 
maxU1 = beta* (phi*U2l + (1-phi)*U2h);
out = (maxcy).^(1-sigma)./(1-sigma) + maxU1 + beta.*sum((1-0).*kappavect.^(1-sigma).*distkappa).*wy.^(1-sigma)./(1-sigma);
out = -out;

maxcll = cll_vect(1);
maxcl = cl_vect(1);
maxchl = chl_vect(1);
maxch = ch_vect(1);

%keyboard
