function out = foch(in, lnchl, k, alpha_vect, sigma, ~, chat, ~, wy, ~, thetah_vect, survprobh, ...
    ~, cmin, cmin2, lambda, ~, nk, kappavect, distkappa, ~)


%pass in c_NH-chat for NH cases
%cll_vect = zeros(1,nk);
%cl_vect = zeros(1,nk);
chl_vect = zeros(1,nk);
ch_vect = zeros(1,nk);

if (cmin > chat && cmin2 == 0) %solve for consumption when kappa shock is largest
    %cll_vect(1) = exp(in(1))+chat;
    %cl_vect(nk)  = exp(in(2));
    chl_vect(k) = exp(lnchl)+chat;
    ch_vect(nk)  = exp(in);
    %cll_vect(2:nk) = max(cmin,cll_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    %cl_vect(1:nk-1) = cl_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    chl_vect(1:k-1) = chl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    chl_vect(k+1:nk) = cmin;
    ch_vect(1:nk-1) = ch_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
else %(cmin > chat && cmin2 > 0) %solve for consumption when kappa shock is largest when not in NH and smallest when in NH
    %cll_vect(1) = exp(in(1))+chat;
    %cl_vect(1)  = exp(in(2));
    chl_vect(k) = exp(lnchl)+chat;
    ch_vect(1)  = exp(in);
    %tl = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - cl_vect(1); 
    %th = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - ch_vect(1);     
    %cll_vect(2:nk) = max(cmin,cll_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    %cl_vect(2:nk) = max(cmin2-tl,cl_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    chl_vect(1:k-1) = chl_vect(k) + (kappavect(k) - kappavect(1:k-1)).*wy;
    chl_vect(k+1:nk) = cmin;
    %ch_vect(2:nk) = max(cmin2-th,ch_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);   
    ch_vect(2:nk) = max(cmin2,ch_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);   
end  

dUtemp = alpha_vect.* survprobh.*thetah_vect .* (chl_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
%dU2hhdxh = dUtemp(1) + sum(dUtemp2(chl_vect(2:nk)>cmin));
dU2hhdxh = dUtemp(1) + sum(dUtemp2(1:k-1));
%dUtemp3 = alpha_vect.*survprobh.*(1-thetah_vect) .* ch_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobh).*udeathprime(ch_vect) .*distkappa;
dUtemp3 = alpha_vect.*(1-thetah_vect.*survprobh) .* ch_vect.^(-sigma) .*distkappa;
%dU2hhdth =-dUtemp(1) - sum(dUtemp2(chl_vect(2:nk)>cmin)) -sum(dUtemp3);
dUtemp4 = dUtemp3(2:nk);
dU2hhdth =-dUtemp(1) - sum(dUtemp2(1:k-1))- dUtemp3(1) -sum(dUtemp4(ch_vect(2:nk)>cmin2));
out = lambda.*survprobh.*sum(thetah_vect.*distkappa) + dU2hhdxh./dU2hhdth;

