function [nbcvect, out] = focs_fake3(in, kil, kjh, alpha_vect, sigma, r, l, chat, ~, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh, ...
    as, cmin, cmin2, lambda, assumexhl, ls, nk, kappavect, distkappa, ~, ~)


%pass in c_NH-chat for NH cases
cll_vect = zeros(1,nk);
cl_vect = zeros(1,nk);
chl_vect = zeros(1,nk);
ch_vect = zeros(1,nk);

if (cmin <= chat && cmin2 ==0) %solve for consumption when kappa shock is largest
    cll_vect(nk) = exp(in(3))+chat;
    cl_vect(nk)  = exp(in(4));
    chl_vect(nk) = exp(in(1))+chat;
    ch_vect(nk)  = exp(in(2));
    cll_vect(1:nk-1) = cll_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    cl_vect(1:nk-1) = cl_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    chl_vect(1:nk-1) = chl_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    ch_vect(1:nk-1) = ch_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    xh = chl_vect(nk)-ch_vect(nk)+l; 
elseif (cmin > chat && cmin2 == 0) %solve for consumption when kappa shock is largest
    cll_vect(kil) = exp(in(3))+chat;
    cl_vect(nk)  = exp(in(4));
    chl_vect(kjh) = exp(in(1))+chat;
    ch_vect(nk)  = exp(in(2));
    
    cll_vect(1:kil-1) = cll_vect(kil) + (kappavect(kil) - kappavect(1:kil-1)).*wy;
    cll_vect(kil+1:nk) = cmin;
    cl_vect(1:nk-1) = cl_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    
    chl_vect(1:kjh-1) = chl_vect(kjh) + (kappavect(kjh) - kappavect(1:kjh-1)).*wy;
    chl_vect(kjh+1:nk) = cmin;
    ch_vect(1:nk-1) = ch_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    xh = chl_vect(1)-ch_vect(1)+l; 
elseif (cmin <= chat && cmin2 > 0) %solve for consumption when kappa shock is largest when not in NH and smallest when in NH
    cll_vect(nk) = exp(in(3))+chat;
    cl_vect(1)  = exp(in(4));
    chl_vect(nk) = exp(in(1))+chat;
    ch_vect(1)  = exp(in(2));
    
    %tl = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - cl_vect(1); 
    %th = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - ch_vect(1); 
    cll_vect(1:nk-1) = cll_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    cl_vect(2:nk) = max(cmin2,cl_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    chl_vect(1:nk-1) = chl_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;
    %ch_vect(2:nk) = max(cmin2-th,ch_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    ch_vect(2:nk) = max(cmin2,ch_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    xh = chl_vect(nk)-ch_vect(nk)+l;
else %(cmin > chat && cmin2 > 0) %solve for consumption when kappa shock is largest when not in NH and smallest when in NH
    
    cll_vect(kil) = exp(in(3))+chat;
    cl_vect(1)  = exp(in(4));
    
    chl_vect(kjh) = exp(in(1))+chat;
    ch_vect(1)  = exp(in(2));
    %tl = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - cl_vect(1); 
    %th = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(1)*wy - ch_vect(1);     
    
    cll_vect(1:kil-1) = cll_vect(kil) + (kappavect(kil) - kappavect(1:kil-1)).*wy;
    cll_vect(kil+1:nk) = cmin;
    cl_vect(2:nk) = max(cmin2,cl_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    
    chl_vect(1:kjh-1) = chl_vect(kjh) + (kappavect(kjh) - kappavect(1:kjh-1)).*wy;
    chl_vect(kjh+1:nk) = cmin;
    
    %ch_vect(2:nk) = max(cmin2-th,ch_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    ch_vect(2:nk) = max(cmin2,ch_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
    xh = chl_vect(1)-ch_vect(1)+l;       
end  

cl0_vect = max(cmin,(1+r)*as - l  +(1-tau)*wo+ls-r*as*tau - kappavect.*wy); 
c0_vect = max(cmin2,(1+r)*as+(1-tau)*wo+ls-r*as*tau - kappavect.*wy);

% U2ll = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* cl_vect.^(1-sigma)./(1-sigma)) + ...
%     (1-survprobl).*udeath(cl_vect)).*distkappa ); 
% U2hh = sum( alpha_vect.*(survprobh.*(thetah_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* ch_vect.^(1-sigma)./(1-sigma)) + ...
%     (1-survprobh).*udeath(ch_vect)).*distkappa ); 
% U2hl = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* cl_vect.^(1-sigma)./(1-sigma)) + ...
%     (1-survprobh).*udeath(cl_vect)).*distkappa ); 
% U2h0 = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
%     (1-survprobh).*udeath(c0_vect)).*distkappa ); 
% U2lh = sum( alpha_vect.*(survprobl.*(thetal_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* ch_vect.^(1-sigma)./(1-sigma)) + ...
%     (1-survprobl).*udeath(ch_vect)).*distkappa ); 

U2ll = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* cl_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*cl_vect.^(1-sigma)./(1-sigma)).*distkappa ); 
U2hh = sum( alpha_vect.*(survprobh.*(thetah_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* ch_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*ch_vect.^(1-sigma)./(1-sigma)).*distkappa ); 
U2hl = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* cl_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*cl_vect.^(1-sigma)./(1-sigma)).*distkappa ); 
U2h0 = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*c0_vect.^(1-sigma)./(1-sigma)).*distkappa ); 
U2lh = sum( alpha_vect.*(survprobl.*(thetal_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* ch_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*ch_vect.^(1-sigma)./(1-sigma)).*distkappa ); 
U2l0 = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*c0_vect.^(1-sigma)./(1-sigma)).*distkappa ); 

dUtemp = alpha_vect.* survprobh.*thetah_vect .* (chl_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
%dU2hhdxh = dUtemp(1) + sum(dUtemp2(chl_vect(2:nk)>cmin));
dU2hhdxh = dUtemp(1) + sum(dUtemp2(1:kjh-1));
%dUtemp3 = alpha_vect.*survprobh.*(1-thetah_vect) .* ch_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobh).*udeathprime(ch_vect) .*distkappa
dUtemp3 = alpha_vect.*(1-thetah_vect.*survprobh) .* ch_vect.^(-sigma) .*distkappa;
%dU2hhdth =-dUtemp(1) - sum(dUtemp2(chl_vect(2:nk)>cmin)) -sum(dUtemp3);
%dU2hhdth =-dUtemp(1) - sum(dUtemp2(1:kjh-1)) -sum(dUtemp3);
dUtemp4 = dUtemp3(2:nk);
dU2hhdth =-dUtemp(1) - sum(dUtemp2(1:kjh-1))- dUtemp3(1) -sum(dUtemp4(ch_vect(2:nk)>cmin2));


dUtemp = alpha_vect.* survprobl.*thetal_vect .* (cll_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
%dU2hhdxh = dUtemp(1) + sum(dUtemp2(chl_vect(2:nk)>cmin));
dU2lldxl = dUtemp(1) + sum(dUtemp2(1:kil-1));
%dUtemp3 = alpha_vect.*survprobh.*(1-thetah_vect) .* ch_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobh).*udeathprime(ch_vect) .*distkappa
dUtemp3 = alpha_vect.*(1-thetal_vect.*survprobl) .* cl_vect.^(-sigma) .*distkappa;
%dU2hhdth =-dUtemp(1) - sum(dUtemp2(chl_vect(2:nk)>cmin)) -sum(dUtemp3);
%dU2hhdth =-dUtemp(1) - sum(dUtemp2(1:kjh-1)) -sum(dUtemp3);
dUtemp4 = dUtemp3(2:nk);
dU2lldtl =-dUtemp(1) - sum(dUtemp2(1:kil-1))- dUtemp3(1) -sum(dUtemp4(cl_vect(2:nk)>cmin2));
             
dUtemp = alpha_vect.* survprobh.*thetah_vect .* (cll_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
%dU2hhdxh = dUtemp(1) + sum(dUtemp2(chl_vect(2:nk)>cmin));
dU2hldxl = dUtemp(1) + sum(dUtemp2(1:kil-1));
%dUtemp3 = alpha_vect.*survprobh.*(1-thetah_vect) .* ch_vect.^(-sigma) .*distkappa + alpha_vect.*(1-survprobh).*udeathprime(ch_vect) .*distkappa
dUtemp3 = alpha_vect.*(1-thetah_vect.*survprobh) .* cl_vect.^(-sigma) .*distkappa;
%dU2hhdth =-dUtemp(1) - sum(dUtemp2(chl_vect(2:nk)>cmin)) -sum(dUtemp3);
%dU2hhdth =-dUtemp(1) - sum(dUtemp2(1:kjh-1)) -sum(dUtemp3);
dUtemp4 = dUtemp3(2:nk);
dU2hldtl =-dUtemp(1) - sum(dUtemp2(1:kil-1))- dUtemp3(1) -sum(dUtemp4(cl_vect(2:nk)>cmin2));

nbcvect = zeros(4,1);

out(1) = U2hh - U2hl; %IC2h (4)
if (assumexhl == 0)
    out(2) = lambda.*survprobh.*sum(thetah_vect.*distkappa) + dU2hhdxh./dU2hhdth;
else
    out(2) = xh-l-chat;
end

out(3) =  lambda.*phi.*survprobl.*sum(thetal_vect.*distkappa) + phi.*dU2lldxl./dU2lldtl ...
    - (1-phi).*( -dU2hldtl./dU2hhdth .*dU2lldxl./dU2lldtl + dU2hldxl./dU2hhdth );
out(4) =  U2ll - U2l0; %PC2l (1)

nbcvect(1) = U2hh - U2h0; %PC2h (3)
nbcvect(2) = U2ll - U2lh; %IC2l (2)    

%keyboard
        
