function [nbcvect, out]  = focshonly_fake(in, alpha_vect, sigma, r, chat, l, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh, ...
    as, caseno, cmin, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime)

chl_vect = zeros(1,nk);
ch_vect = zeros(1,nk);

chl_vect(1) = exp(in(1))+chat;
ch_vect(nk)  = exp(in(2));
chl_vect(2:nk) = max(cmin,chl_vect(1) + (kappavect(1) - kappavect(2:nk)).*wy);
ch_vect(1:nk-1) = ch_vect(nk) + (kappavect(nk) - kappavect(1:nk-1)).*wy;

lambda3 = in(3);
lambda2 = in(4);

cll_vect = max((1+r)*as - l+(1-tau)*wo-r*as*tau+ls- kappavect.*wy,cmin); 
cl_vect = (1+r)*as +(1-tau)*wo+ls-r*as*tau - kappavect.*wy;
cl0_vect = max((1+r)*as - l+(1-tau)*wo-r*as*tau+ls- kappavect.*wy,cmin); 
c0_vect = (1+r)*as +(1-tau)*wo+ls-r*as*tau - kappavect.*wy;


U2ll = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* cl_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*udeath(cl_vect)).*distkappa ); 
U2l0 = sum( alpha_vect.*(survprobl.*(thetal_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*udeath(c0_vect)).*distkappa ); 
U2hh = sum( alpha_vect.*(survprobh.*(thetah_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* ch_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*udeath(ch_vect)).*distkappa ); 
U2hl = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cll_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* cl_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*udeath(cl_vect)).*distkappa ); 
U2h0 = sum( alpha_vect.*(survprobh.*(thetah_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* c0_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobh).*udeath(c0_vect)).*distkappa ); 
U2lh = sum( alpha_vect.*(survprobl.*(thetal_vect .* (chl_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* ch_vect.^(1-sigma)./(1-sigma)) + ...
    (1-survprobl).*udeath(ch_vect)).*distkappa ); 

dUtemp = alpha_vect.* survprobh.*thetah_vect .* (chl_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
dU2hhdxh = dUtemp(1) + sum(dUtemp2(chl_vect(2:nk)>cmin));
dU2h0dxh = 0;
dU2lldxh = 0;
dU2hhdth =-dUtemp(1) - sum(dUtemp2(chl_vect(2:nk)>cmin)) -sum(alpha_vect.*survprobh.*(1-thetah_vect) .* ch_vect.^(-sigma) .*distkappa) ...
    - sum(alpha_vect.*(1-survprobh).*udeathprime(ch_vect) .*distkappa);

dUtemp = alpha_vect.* survprobl.*thetal_vect .* (chl_vect-chat).^(-sigma) .*distkappa;
dUtemp2 = dUtemp(2:nk);
dU2lhdxh = dUtemp(1) + sum(dUtemp2(chl_vect(2:nk)>cmin));
dU2h0dth = 0;
dU2lldth = 0;
dU2lhdth = -dUtemp(1) - sum(dUtemp2(chl_vect(2:nk)>cmin)) -sum(alpha_vect.*survprobl.*(1-thetal_vect) .* ch_vect.^(-sigma) .*distkappa) ...
    - sum(alpha_vect.*(1-survprobl).*udeathprime(ch_vect) .*distkappa);

nbcvect = zeros(4,1);

out(1) = -(1-phi)*lambda*survprobh*sum(thetah_vect.*distkappa) - lambda3 * (dU2hhdxh - dU2h0dxh)  - lambda2 * (dU2lldxh - dU2lhdxh); %focxh 
                     
out(2) = 1-phi - lambda3 * (dU2hhdth - dU2h0dth)  - lambda2 * (dU2lldth - dU2lhdth); %focth  

switch caseno

   case 1                          

        out(3) = U2hh - U2h0; %PC2h (1)
        out(4) = lambda2;
        %     out(6) = U2hh - U2hl; %IC2h (4)
        %     out(7) = lambda3; %PC2h (3)
        %     out(8) = lambda2; %IC2l (2)

        nbcvect(1) = U2ll - U2l0; %PC2l (3)
        nbcvect(2) = U2ll - U2lh; %IC2l (2)
        nbcvect(3) = U2hh - U2hl; %IC2h (2)
        
    case 2    

        out(3) = lambda3;
        out(4) = U2ll - U2lh;
        %     out(6) = U2hh - U2hl; %IC2h (4)
        %     out(7) = lambda3; %PC2h (3)
        %     out(8) = lambda2; %IC2l (2)

        nbcvect(1) = U2ll - U2l0; %PC2l (3)
        nbcvect(2) = U2hh - U2h0; %PC2h (1)
        nbcvect(3) = U2hh - U2hl; %IC2h (2)
        
    case 3    

        out(3) = U2hh - U2h0;
        out(4) = U2ll - U2lh;
        %     out(6) = U2hh - U2hl; %IC2h (4)
        %     out(7) = lambda3; %PC2h (3)
        %     out(8) = lambda2; %IC2l (2)

        nbcvect(1) = U2ll - U2l0; %PC2l (3)
        nbcvect(2) = U2hh - U2hl; %IC2h (2)
                  
end
%keyboard
    
