function [U0mat, U1mat, asmat, postaslmat, postashmat, xlsmat, xhsmat, tlsmat, ...
    thsmat, cysmat, chNHsmat, clNHsmat, ch0smat, cl0smat, profitsmat, MTSIh, ...
    MTSIl, optcasemat, poolsolmat, translmat, transhmat, translmat2, transhmat2, ...
    translmat21, transhmat21, translmat22, transhmat22, translmat31, transhmat31, translmat32, transhmat32, Oncfloorsmat]=...
    govtbudget(tau, nk, soltype, sigma, r, l, chat, chat2, thetalmat, thetahmat, survprobslmat, survprobshmat, beta, alpha_vect, ...
    cmin, cmin2, cmin3, lambda, k, distkappa, kappavect, ny, nh, phimat, ymat, yomat, lsmat, distyh, udeath, udeathprime)
%takes the tax rate and returns government revenues - transfers

U0mat = zeros(ny,nh);
U1mat = zeros(ny,nh);
asmat = zeros(ny,nh);
xlsmat = zeros(ny,nh);
xhsmat = zeros(ny,nh);
tlsmat = zeros(ny,nh);
thsmat = zeros(ny,nh); 
cysmat = zeros(ny,nh); 
chNHsmat = zeros(ny,nh,nk); 
clNHsmat = zeros(ny,nh,nk); 
ch0smat = zeros(ny,nh,nk); 
cl0smat = zeros(ny,nh,nk); 
profitsmat = zeros(ny,nh);
MTSIh = zeros(ny,nh,nk); 
MTSIl = zeros(ny,nh,nk); 
optcasemat = zeros(ny,nh); 
poolsolmat = zeros(ny,nh);
translmat = zeros(ny,nh,nk); 
transhmat = zeros(ny,nh,nk); 
translmat2 = zeros(ny,nh);
transhmat2 = zeros(ny,nh);
transhmat21 = zeros(ny,nh,nk);  
translmat21 = zeros(ny,nh,nk); 
translmat22 = zeros(ny,nh);
transhmat22 = zeros(ny,nh);
transhmat31 = zeros(ny,nh,nk);  
translmat31 = zeros(ny,nh,nk); 
translmat32 = zeros(ny,nh);
transhmat32 = zeros(ny,nh);
postashmat = zeros(ny,nh,nk); 
postaslmat = zeros(ny,nh,nk); 
Oncfloorsmat = zeros(ny,nh);

 %%%%%%%%%%HERE%%%%%%%%%%%
%load asmat_1.mat;
%asmat_temp = asmat_20180228_123759;

%spmd, mpiprofile('on'); end
%parfor yi = 43:ny
parfor yi = 1:ny
%for yi = 127:128
%parfor yi = 88:ny
%parfor yi = 1:90
%parfor yi = 26:ny
%for yi = 121:ny
%for yi=1:90
    fprintf(1,'yi=%g\n',yi);

    for hi = 1:5
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       % if (yi==127 && hi==3)
       %     soltype = 2;
       % else
       %     soltype = 1;
       % end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
   %     fprintf(1,'start: yi=%g hi=%g\n',yi,hi);
    %hi    
           
       phi = phimat(yi,hi); %probability low type
       wy = ymat(yi,hi);
       wo = yomat(yi,hi);
       ls = lsmat(yi,hi)*(1-tau); %post-tax lump-sum transfer of monopolist profits 
       thetal_vect = squeeze(thetalmat(yi,hi,:))';
       thetah_vect = squeeze(thetahmat(yi,hi,:))';
       survprobl = survprobslmat(yi,hi);
       survprobh = survprobshmat(yi,hi);
    
       %%%%%%%%%%HERE%%%%%%%%%%%
       % chat2 = asmat_temp(yi,hi);
       
       [U0_out, as_out, maxprofitsvect, maxtlvect, maxxlvect, maxthvect, maxxhvect, ...
    optcase, poolsolvect, maxcy, maxcll, maxchl, maxcl, maxch, maxU1, Oncfloors] = govtbudget_objective(phi, wy, wo, ls, nk, soltype, sigma, r, l, ...
           chat, chat2, tau, thetal_vect, thetah_vect, survprobl, survprobh, beta, alpha_vect, cmin, cmin2, cmin3, lambda, k, ...
           distkappa, kappavect, udeath, udeathprime);

       U0mat(yi,hi) = U0_out;
       asmat(yi,hi) = as_out;
       
       tlsmat(yi,hi) = maxtlvect(optcase);
       xlsmat(yi,hi) = maxxlvect(optcase);
       thsmat(yi,hi) = maxthvect(optcase);
       xhsmat(yi,hi) = maxxhvect(optcase);        
       %keyboard
       %Saves only the consumptions when kappa = kappavect(1)      
        if (cmin <= chat && cmin2 ==0)
           cysmat(yi,hi) = maxcy;
           chNHsmat(yi,hi,:) = maxchl  + kappavect(1)*wy - kappavect*wy ;
           clNHsmat(yi,hi,:) = maxcll  + kappavect(1)*wy - kappavect*wy ;
           ch0smat(yi,hi,:) = maxch  + kappavect(1)*wy - kappavect*wy ; 
           cl0smat(yi,hi,:) = maxcl  + kappavect(1)*wy - kappavect*wy ;    
        elseif (cmin > chat && cmin2 == 0)
           cysmat(yi,hi) = maxcy;
           chNHsmat(yi,hi,:) = max(maxchl  + kappavect(1)*wy - kappavect*wy, cmin) ;
           clNHsmat(yi,hi,:) = max(maxcll  + kappavect(1)*wy - kappavect*wy, cmin) ;
           ch0smat(yi,hi,:) = maxch + kappavect(1)*wy - kappavect*wy ;
           cl0smat(yi,hi,:) = maxcl + kappavect(1)*wy - kappavect*wy ;  
        elseif (cmin <= chat && cmin2 > 0)
           cysmat(yi,hi) = maxcy;
           chNHsmat(yi,hi,:) = maxchl  + kappavect(1)*wy - kappavect*wy ;
           clNHsmat(yi,hi,:) = maxcll  + kappavect(1)*wy - kappavect*wy ;
%            ch0smat(yi,hi,:) = max(maxch  + kappavect(1)*wy - kappavect*wy, cmin2-thsmat(yi,hi)) ; 
%            cl0smat(yi,hi,:) = max(maxcl  + kappavect(1)*wy - kappavect*wy, cmin2-tlsmat(yi,hi)) ;  
           ch0smat(yi,hi,:) = max(maxch  + kappavect(1)*wy - kappavect*wy, cmin2) ; 
           cl0smat(yi,hi,:) = max(maxcl  + kappavect(1)*wy - kappavect*wy, cmin2) ;             
        else %(cmin > chat && cmin2 > 0)
           cysmat(yi,hi) = maxcy;
           chNHsmat(yi,hi,:) = max(maxchl  + kappavect(1)*wy - kappavect*wy, cmin) ;
           clNHsmat(yi,hi,:) = max(maxcll  + kappavect(1)*wy - kappavect*wy, cmin) ;
%            ch0smat(yi,hi,:) = max(maxch + kappavect(1)*wy - kappavect*wy, cmin2-thsmat(yi,hi)) ; 
%            cl0smat(yi,hi,:) = max(maxcl + kappavect(1)*wy - kappavect*wy, cmin2-tlsmat(yi,hi)) ;   
           ch0smat(yi,hi,:) = max(maxch + kappavect(1)*wy - kappavect*wy, cmin2) ; 
           cl0smat(yi,hi,:) = max(maxcl + kappavect(1)*wy - kappavect*wy, cmin2) ;             
        end         
       U1mat(yi,hi) = maxU1;
        
       if asmat(yi,hi) == 0 
           ch0smat(yi,hi,:) = max(maxch  + kappavect(1)*wy - kappavect*wy, cmin3) ; 
           cl0smat(yi,hi,:) = max(maxcl  + kappavect(1)*wy - kappavect*wy, cmin3) ;
       end
        
       Oncfloorsmat(yi,hi) = Oncfloors;
 
       transhmat(yi,hi,:) = max(0,cmin - ((1+r)*asmat(yi,hi) - l + xhsmat(yi,hi) - thsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy ));
       translmat(yi,hi,:) = max(0,cmin - ((1+r)*asmat(yi,hi) - l + xlsmat(yi,hi) - tlsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy));       
       postashmat(yi,hi,:) = (1+r)*asmat(yi,hi) - thsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy;
       postaslmat(yi,hi,:) = (1+r)*asmat(yi,hi) - tlsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy;
       translmat2(yi,hi) = sum(squeeze(thetalmat(yi,hi,:).*translmat(yi,hi,:)).*distkappa');
       transhmat2(yi,hi) = sum(squeeze(thetahmat(yi,hi,:).*transhmat(yi,hi,:)).*distkappa');
       profitsmat(yi,hi) = maxprofitsvect(optcase); 
       optcasemat(yi,hi) = optcase; 
       poolsolmat(yi,hi) = poolsolvect(optcase); 
       
       
%        transhmat21(yi,hi,:) = max(0,cmin2 - ((1+r)*asmat(yi,hi)  - thsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy ));
%        translmat21(yi,hi,:) = max(0,cmin2 - ((1+r)*asmat(yi,hi)  - tlsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy ));
%        transhmat22(yi,hi) = sum(squeeze((1-repmat(survprobshmat(yi,hi),[1 1 nk]).*thetahmat(yi,hi,:)).*transhmat21(yi,hi,:)).*distkappa'); 
%        translmat22(yi,hi) = sum(squeeze((1-repmat(survprobslmat(yi,hi),[1 1 nk]).*thetalmat(yi,hi,:)).*translmat21(yi,hi,:)).*distkappa'); 
       
        if (asmat(yi,hi) == 0)
           transhmat31(yi,hi,:) = max(0,cmin3 - ((1+r)*asmat(yi,hi)  - thsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy));
           translmat31(yi,hi,:) = max(0,cmin3 - ((1+r)*asmat(yi,hi)  - tlsmat(yi,hi) + wo*(1-tau) + ls - tau*r*asmat(yi,hi) -kappavect.*wy ));
           transhmat32(yi,hi) = sum(squeeze((1-repmat(survprobshmat(yi,hi),[1 1 nk]).*thetahmat(yi,hi,:)).*transhmat31(yi,hi,:)).*distkappa'); 
           translmat32(yi,hi) = sum(squeeze((1-repmat(survprobslmat(yi,hi),[1 1 nk]).*thetalmat(yi,hi,:)).*translmat31(yi,hi,:)).*distkappa');
        end
       if (~isreal(xlsmat(yi,hi)))  
            fprintf(1,'Imaginary numbers in xlsmat\n'); 
            %keyboard
       end   
      fprintf(1,'yi=%g hi=%g xh=%g xl=%g tl=%g th=%g U0=%g as=%g pfts=%g\n',yi,hi,xhsmat(yi,hi), xlsmat(yi,hi),tlsmat(yi,hi),thsmat(yi,hi), U0mat(yi,hi),asmat(yi,hi), profitsmat(yi,hi));
%         if (xhsmat(yi,hi)>0)
%             keyboard
%         end
%         if (yi==19 && hi == 4)
%            keyboard
%         end
%keyboard
     %   fprintf(1,'end: yi=%g hi=%g\n',yi,hi);
    end 
%    keyboard
end
%spmd, mpiprofile('viewer'); end

% for yi = 1:ny
%     for hi =1:nh
%        MTSIh(yi,hi,(transhmat(yi,hi,:) > 0)) = 1;
%        MTSIl(yi,hi,(translmat(yi,hi,:) > 0)) = 1;
%     end
% end

MTSIh(transhmat > 0) = 1;
MTSIl(translmat > 0) = 1;       

checksolxl = xlsmat < -1e-1;
if  sum(sum(sum(checksolxl))) > 0
    fprintf('xlsmat has negative numbers\n');
    %keyboard;
end
xlsmat(xlsmat<1e-10) = 0;

checksolxh = xhsmat < -1e-1;
if  sum(sum(sum(checksolxh))) > 0
    fprintf('xhsmat has negative numbers\n');
    %keyboard;
end
xhsmat(xhsmat<1e-10) = 0;

checksolxl = xlsmat - l -chat > 1e-1;
if  sum(sum(sum(checksolxl))) > 0
    fprintf('xlsmat has numbers larger than l\n');
    %keyboard;
end
xlsmat(abs(xlsmat-l) < 1e-10) = l;

checksolxh = xhsmat - l -chat > 1e-1;
if  sum(sum(sum(checksolxh))) > 0
    fprintf('xhsmat has numbers larger than l\n');
    %keyboard;
end
xhsmat(abs(xhsmat-l-chat ) < 1e-10) = l+chat;

checksoltl = tlsmat < -1e-1;
if  sum(sum(sum(checksoltl))) > 0
    fprintf('tlsmat has negative numbers\n');
    %keyboard;
end
tlsmat(tlsmat<1e-10) = 0;

checksolth = thsmat < -1e-1;
if  sum(sum(sum(checksolth))) > 0
    fprintf('thsmat has negative numbers\n');
    %keyboard;
end
thsmat(thsmat<1e-10) = 0;


